Subject: RE: bug#43702: Emacs master: Incorrect highlighting in regexp isearch.

From: Drew Adams <[email-masked]>
Date: Wed, 7 Oct 2020 08:42:10 -0700 (PDT)

> > I don't agree, but won't argue about it.  I redefined
> > `replace-highlight' and `replace-dehighlight' so they
> > do highlight regexp groups, and I think it's helpful.
> 
> After query-replace is started, the regexp is already created
> (either with the help of isearch group submatches highlighting
> or typed directly on the query-replace prompt), so during replacements
> the user has only to decide for each match whether to replace it or not
> by answering the y/n question for the currently highlighted regexp.
> 
> How highlighting the replacement submatches will help the user to decide
> whether to replace the current match or not?

Whether to replace a given match is not the only thing
a user can do - not the only thing to decide/consider.

Highlighting groups helps you see _how_ a regexp matches.

And you can always change a regexp and search/replace
again, if it's either not matching something you want
to match or matching too many things you don't want to
match.

It's helpful in pretty much any context where regexps
are matched against text, IMO.